-- universelles Script fr eine neue/vorhandene Anlage von Parry36.
-- Anlage "Stadt - Land - Fluss" von BR53 - Heinrich

local t  = 0
math.randomseed(os.time())
require("P36_Tool_Box")
require("Slot_tab_Data")
require("ZZA_Stadt_Land_Fluss")

print("\n Zeitstempel:  ", P36_time(), ",\n Anlage: Stadt - Land - Fluss")
print(" EEP Version:  ", EEPVer, " Lua Version:  ", _VERSION, "\n")

sloteinlesen()      -- beim Anlagenstart die Daten einlesen
info_tabData()

-- Routenzusammenfassung nur als Beispiele
local a_routenG = {"Gueter","Gefahrgut","Kohlen"} 
local a_routenP = {"ICE","Personen","Regional","Sonderfahrt"}
local a_routenR = {"Personen","Regional","Wende"}
local a_routenD = {"Personen", "D-Zug"}
local a_routenI = {"ICE", "Regional", "IC"}
-- Tabelle der Mehrweg - Fahrstrassen
local a_znSlot = {[54] = {trigger = true,        --------- generieren von Funktionen
							s_text  = "angefordert, von Sd nach HbF",
							routen  = {{"NzgK_S_HBF",}, {"Fzg_S_HBF",}},
							f_wege  = { {2}, {3},  },
							on_text = {"FS_54, geschaltet, Sd - Gleis 6a",
										"FS_54, geschaltet, Sd - Gleis 8",} },
				[182] = {trigger = true,        --------- generieren von Funktionen
							s_text  = "angefordert, von Nord nach HbF",
							routen  = {{"Nzg_S2_0",}, {"Wzg_S2_0",}, {"Fzg_S2_0"}},
							f_wege  = { {5}, {2}, {3, 4}  },
							on_text = {"FS_182, geschaltet, Nord - Gleis 1a",
										"FS_182, geschaltet, Nord - Gleis 3",
										"FS_182, geschaltet, Nord - Gleis 2",
										"FS_182, geschaltet, Nord - Gleis 1",}},
				
				}

--[[ nur ein Beispiel fr FS_412
local a_znSlot = {[192] = {trigger = true,        --------- generieren von Funktionen
							s_text  = "angefordert, von Ost nach Nord 2 - Depot 9",
							routen  = {{"F_Zg_41", "F_Zg_51", "I_Zg_41" , "R_Zg_41", "R_Zg_51",}, a_routenG  },
							f_wege  = { {2}, {3},  },
							on_text = {"FS_192, geschaltet, Ost nach Sd-West ber Dortmund",
										"FS_192, geschaltet, Ost nach Nord 2",} },
				[201] = {trigger = true,       ---------  
							s_text  = "angefordert, Dortmund HBF aus Ost",
							routen  = {{"F_Zg_41"}, {"R_Zg_41"}, {"I_Zg_41"},{"F_Zg_51", "R_Zg_51"},},
							f_wege  = { {2,3}, {4},{5}, {7,6}, },
							on_text = {"FS_201, geschaltet, Dortmund HBF, Einfahrt Ost nach Gleis 10",
										"FS_201, geschaltet, Dortmund HBF, Einfahrt Ost nach Gleis 8",
										"FS_201, geschaltet, Dortmund HBF, Einfahrt Ost nach Gleis 16",
										"FS_201, geschaltet, Dortmund HBF, Einfahrt Ost nach Gleis 11",
										"FS_201, geschaltet, Dortmund HBF, Einfahrt Ost nach Gleis 21",
										"FS_201, geschaltet, Dortmund HBF, Einfahrt Ost nach Gleis 23",} },
                 } 
]]
 
-- Einweg-Fahrstrassen
local a_pool = {51, 159, 177, 219, 220, 221, 222, 227, 230,}

-- einschlielich --> eventuelle Sonderfunktionen die getriggert sollen 
--[[ 
per Referenzbergabe
function a_pool:Sonderfunktion()
    body ...
end
 ]]
------------ generieren aller Funktionen in a_znSlot -----------
for k, v in pairs(a_znSlot)  do
    
    if   v.trigger    then                  -- Funktionen nur generieren wenn trigger == true
        _ENV["FS_"..k] = function()         -- Funktions-Namen z.B. FS_412 
            local hResult, s_route 
            hResult, s_route = load_tabData(k)          -- Route aus Tabelle laden            
            if  hResult and  EEPGetSignal(k)  == 1   then   -- anmelden prfen
                for n = 1, #v.routen  do                -- Tabelle routen iterieren
                    if  SelectRoute( s_route, v.routen[n])     then 
                        EEPSetSignal(k, fw_random(v.f_wege[n]) , 1)	    -- mit Callback aufrufen
                    end
                end
            end    
        end
        
        v.func = _ENV["FS_"..k]     -- Referenzbergabe der Funktionen an a_znSlot    
        EEPRegisterSignal(k)        -- Signale registrieren trigger == true        
        
        _ENV["EEPOnSignal_"..k] = function(_status)
            if  _status > 1 then
                del_tabData(k)
                print(v.on_text[EEPGetSignal(k)-1])
            end 
        end
    end        
end
--##########----Ende a_znSlot Funktionen-----############

-- Aufruf in der EEPMain() im Anlagen-Script einsetzen!!!!
function inEEPMain()
    t = t + 1
        FS_schalten()
        
    if t%600 == 0 then      
        info_tabData()      -- Info alle 2 Min. anzeigen
    end
	Ampelschaltung.start()	
end

function FS_schalten()        
    -- a_znSlot wird direkt aus der Queue angesprochen
    for k  in pairs((slot_tabData))    do
        if a_znSlot[k] ~= nil   then        -- Schlssel prfen
            local a_val = rawget(a_znSlot, k)
            if  type(a_val.func) == "function"   then          -- Funktion vorgegeben
                a_val.func()
            elseif not a_val.func   then      -- keine Funktion vorgegeben
                if    EEPGetSignal(k)  == 1 then  EEPSetSignal(k, 2) end     -- verriegeln
            end    
        end
    end    
    for _, v in pairs(table2rand(a_pool))    do
        if  type(v) == "number"  then
            if    load_tabData(v)    and  EEPGetSignal(v)  == 1 then  EEPSetSignal(v, 2) end     -- verriegeln 
        elseif type(v) == "function"  then  v() end    
    end    
end
--[[function FS_schalten()		
    for k , v in pairs(table2rand(a_znSlot))	do
        if  not v.func   then          -- keine Funktion vorgegeben  
            if	load_tabData(k)	then  EEPSetSignal(k, 2) end 
        elseif  type(v.func) == "function"   then        
            v.func()
        end    
	end
    
    for _, v in pairs(table2rand(a_pool))	do
        if  type(v) == "number"  then
            if	load_tabData(v)	then  EEPSetSignal(v, 2) end 
        elseif type(v) == "function"  then
            v()
        end    
	end	
end
 ]]
-- Anmelden im KP 
function anmelden(Fs_Id, Zn)
    if not Zn then Zn = Zugname end	
    local hResult, s_route = EEPGetTrainRoute(Zn)
    if hResult  then
        set_tabData(Fs_Id, s_route )
        if not a_znSlot[Fs_Id]    then
            -- print("FS_", Fs_Id, ", angefordert, Zug: ", Zn, ",\nRoute: ", s_route)
        else
            print("FS_", Fs_Id, ", ",a_znSlot[Fs_Id].s_text, "\nZug: ", Zn, ", Route: ", s_route)
        end    
    end
end

-- Abmelden im KP
function abmelden(Fs_Id, Zn)
    if not Zn then  Zn = Zugname   end 
    del_tabData(Fs_Id)
    if not a_znSlot[Fs_Id]    then
        -- print("FS_", Fs_Id, ", geschaltet, Zug: ", Zn)
    end    
end

--------------------------------------------------------------------------------------------
-- Bahnbergnge
Z_BUE_S2 = 0
function BUE_S2_zu()
	Z_BUE_S2 = Z_BUE_S2 + 1
	EEPSetSignal(238,3)
	--print("Schranke wurde geschlossen")	
end
function BUE_S2_auf()
	Z_BUE_S2 = Z_BUE_S2 - 1
	if(Z_BUE_S2 <= 0)then
	EEPSetSignal(238,1)
	--print("Schranke geffnet, frei Fahrt ins Wochenende")
	end
end
---------------------------------------------------------------------------------------------
-- Ampelsteuerungen --- Ampelanlage von JS2 -------------------------------------------------
K_Zaehler = 0
-- 1:Pkw_Rot/F_Rot - 2:Pkw_RotGelb - 3:Pkw_Grn - 4:Pkw_GrnGelb - 5:Pkw_Gelb - 6:Pkw_Rot/F_Grn - 7:Gelb blinken - 8:Aus
Rr, Ry, Gn, Gg, Gb, Rg, Gl, Of = 1,2,3,4,5,6,7,8

Kreuzung = {
	Bhf_Sued_Ost = {
	Signal= { 263, 264, 269, 272, } ,
			{ Rr,   Rr,   Rr,  Rr,   Dauer = 60 } ,
			{ Ry,   Ry,   Rr,  Rr,   Dauer = 10 } ,
			{ Gn,   Gn,   Rr,  Rr,   Dauer = 60 } ,
			{ Ry,   Ry,   Rr,  Rr,   Dauer = 15 } ,
			{ Rr,   Rr,   Rr,  Rr,   Dauer = 20 } ,
			{ Rg,   Rg,   Rr,  Rr,   Dauer = 10 } ,
			{ Rr,   Rr,   Ry,  Rr,   Dauer = 10 } ,
			{ Rr,   Rr,   Gn,  Rr,   Dauer = 40 } ,
			{ Rr,   Rr,   Ry,  Rr,   Dauer = 15 } ,
			{ Rr,   Rr,   Rr,  Rr,   Dauer = 05 } ,
			{ Rr,   Rr,   Rg,  Rr,   Dauer = 40 } ,
			{ Rr,   Rr,   Rr,  Rr,   Dauer = 15 } ,
			{ Rr,   Rr,   Rr,  Ry,   Dauer = 10 } ,
			{ Rr,   Rr,   Rr,  Gn,   Dauer = 40 } ,
			{ Rr,   Rr,   Rr,  Ry,   Dauer = 05 } ,
			{ Rr,   Rr,   Rr,  Rr,   Dauer = 05 } ,
			} ,
	Bhf_Nord_Ost = {
	Signal= { 261, 296, 300, 299, } ,
			{ Rr,   Rr,   Rr,   Rr,  Dauer = 60 } ,
			{ Ry,   Rr,   Rr,   Rr,  Dauer = 10 } ,
			{ Gn,   Rr,   Rr,   Rr,  Dauer = 60 } ,
			{ Gb,   Rr,   Rr,   Rr,  Dauer = 15 } ,						
			{ Rr,   Ry,   Rr,   Rr,  Dauer = 10 } ,
			{ Rr,   Gn,   Rr,   Rr,  Dauer = 60 } ,
			{ Rr,   Gb,   Rr,   Rr,  Dauer = 15 } ,
			{ Rr,   Rr,   Ry,   Rr,  Dauer = 20 } ,
			{ Rr,   Rr,   Gn,   Rr,  Dauer = 80 } ,
			{ Rr,   Rr,   Gb,   Rr,  Dauer = 10 } ,			
			{ Rr,   Rr,   Rr,   Rr,  Dauer = 25 } ,
			{ Rr,   Rr,   Rr,   Ry,  Dauer = 80 } ,
			} ,
}

Ampelschaltung = {
	start = function()
		for _ , Tabelle in pairs( Kreuzung ) do
			Tabelle:Steuerung()
		end
	end ,
	Ausfuehrung = {
		__index = {
			Takt  = 0 ,
			Steuerung = function( self )
				if K_Zaehler % 5 == 0 then
					self.Takt = self.Takt + 1
					if self.Takt >= self[ 1 ].Dauer then
						table.insert( self , table.remove( self , 1 ) )
						for Liste , Signal in ipairs( self.Signal ) do
							EEPSetSignal( Signal , self[ 1 ][ Liste ] )
						end
						self.Takt = 0
					end
					return true
				else
					return false
				end
			end
		} ,
	}
}
for _ , Tabelle in pairs( Kreuzung ) do
	setmetatable( Tabelle , Ampelschaltung.Ausfuehrung)
end



